program mine;
{$APPTYPE CONSOLE}

uses
  SysUtils,
  Classes,
  Sockets,
  igralec in 'igralec.pas';

procedure napaka(s: string; e: LongInt);
begin
     WriteLn(s);
     RunError(e);
end;

procedure mconnect(hostname: string; var sock: LongInt; var Sin: TextFile; var SOut: TextFile);
var
  SAddr: TInetSockAddr;
  buffer: string[255];
begin
  sock := fpSocket(PF_INET, SOCK_STREAM, 0);
  if sock = -1 then RunError(1);
  SAddr.sin_family := AF_INET;
  SAddr.sin_port := htons(1180);
  SAddr.sin_addr.s_addr := HostToNet((127 shl 24) or 1); { = 'localhost' ! }

{ fpConnect(sock, @SAddr, sizeof(SAddr)) = -1 }
  if not Connect(sock, SAddr, Sin, Sout) then
     napaka('Napaka pri povezavi na streznik', 2);

  Reset(Sin);
  ReWrite(SOut);

  ReadLn(Sin, buffer);
  WriteLn(buffer);
  WriteLn(SOut, 'AVE ' + TIgralec.getIme);
  ReadLn(SIn, buffer);
  if buffer <> 'PRIJAVA USPESNA' then
     napaka('Napaka pri povezavi na streznik', 3);
end;

procedure event_loop(var comm_r: TextFile; var comm_w: TextFile);
label adijo;
var
  cmd: string;
  cmda: TStringList;
  t: TIgralec;
  w, h, N_min: LongInt;
  poteza: TPoteza;
begin
  cmda := TStringList.Create;
  cmda.Delimiter := ' ';

  while true do begin
    ReadLn(comm_r, cmd);
    cmda.Clear;
    cmda.DelimitedText := cmd;

    if cmda.Strings[0] = 'ADIJO' then break;
    if cmda.Strings[0] = 'KONEC_IGRE' then begin
       WriteLn(comm_w, 'KONCAL');
       continue;
    end;
    if cmda.Strings[0] <> 'ZACNI' then
       napaka('Napaka v komunikaciji', 4);

    w := StrToInt(cmda.Strings[1]);
    h := StrToInt(cmda.Strings[2]);
    N_min := StrToInt(cmda.Strings[3]);

    t := TIgralec.Create;
    t.zacni_igro(w, h, N_min);
    WriteLn(comm_w, 'ZACEL');

    while true do begin
      ReadLn(comm_r, cmd);
      cmda.Clear;
      cmda.DelimitedText := cmd;

      if cmda.Strings[0] = 'ADIJO' then goto adijo;
      if cmda.Strings[0] = 'KONEC_IGRE' then begin
        t.konec_igre(cmda.Strings[1]);
        t.Free;
        WriteLn(comm_w, 'KONCAL');
        break;
      end else if cmda.Strings[0] = 'POTEZA?' then begin
          poteza := t.naslednja_poteza;
          WriteLn(comm_w, 'POTEZA ' + IntToStr(poteza.x) + ' ' + IntToStr(poteza.y));
      end else if cmda.Strings[0] = 'IZID' then begin
          t.izid(StrToInt(cmda.Strings[1]), StrToInt(cmda.Strings[2]), StrToInt(cmda.Strings[3]) > 0, StrToInt(cmda.Strings[4]));
          WriteLn(comm_w, 'MHM');
      end;
    end;
  end;
adijo:
end;

var
   sock: LongInt;
   comm_r, comm_w: TextFile;
   hostname: string;
begin
  { opomba: funkcija connect se vedno poveze na localhost... }
  if ParamCount() < 2 then hostname:= 'localhost'
  else hostname := ParamStr(1);

  mconnect(hostname, sock, comm_r, comm_w);
  event_loop(comm_r, comm_w);
end.
